local addon, rhud = ...
--rhudunitid = {}
function rhud.AdjustTable(unitId, member, value)
	for key, ret in pairs(rhud.unitDB) do
		if unitId == ret.id then
			rhud.unitDB[key][member] = value
		end
	end
end
local function rhudAbsorbUpdate(hEvent, details)
	for unitId,value in pairs(details) do rhud.AdjustTable(unitId, "absorb", value)
		unitID = rhud.unitDB["player"]
		if unitId == unitID.id then
			if (unitID.absorb == nil or unitID.absorb == false) then 
				rhud.PlayerStat[8] = 0
				rhud.arctext[1]:SetText("0")
				rhud.fillarc(0, 100, 1)
			elseif unitID.absorb ~= nil and unitID.healthMax ~= nil then
				rhud.PlayerStat[8] = unitID.absorb
				if unitID.absorb > unitID.healthMax then unitID.absorb = unitID.healthMax end
				rhud.arctext[1]:SetText(string.format("%s", (math.ceil(unitID.absorb/unitID.healthMax * 100))))
				rhud.fillarc(unitID.absorb, unitID.healthMax, 1)
			end
		end
	end
end
local function throttle(var1, var2, var3, perc)
	if var1 == nil then return true end
	if var2 > math.ceil(var3 - (var3 * (perc/100))) then return true end
	if math.abs(var1 - var2) > math.ceil(var3 * (perc/100)) then
		return true
	end
	
end
local function rhudHpUpdate(hEvent,details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "health", value)
		for key,unitID in pairs(rhud.unitDB) do
			if unitId == unitID.id and unitID.health and unitID.healthMax then
				perc = throttle(unitID.old_health, unitID.health, unitID.healthMax, 2)
				if perc == true then
					if unitID.index == 1 then rhud.PlayerStat[2] = unitID.health rhud.PlayerStat[3] = unitID.healthMax end
					if unitID.index == 1 or unitID.index == 2 then rhud.hptext[unitID.index]:SetText(tostring(unitID.health)) end
					unitID.old_health = unitID.health
					rhud.arctext[unitID.hindex]:SetText(string.format("%s", (math.ceil(unitID.health/unitID.healthMax * 100))))
					rhud.fillarc(unitID.health, unitID.healthMax, unitID.hindex)
				end
			end
		end
	end
end
local function rhudHpMaxUpdate(hEvent,details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "healthMax", value)
		for key,unitID in pairs(rhud.unitDB) do
			if unitId == unitID.id then
				if unitID.index == 1 then rhud.PlayerStat[2] = unitID.health rhud.PlayerStat[3] = unitID.healthMax end
				if unitID.index == 1 or unitID.index == 2 then rhud.hptext[unitID.index]:SetText(tostring(unitID.health)) end
				rhud.arctext[unitID.hindex]:SetText(string.format("%s", (math.ceil(unitID.health/unitID.healthMax * 100))))
				rhud.fillarc(unitID.health, unitID.healthMax, unitID.hindex)
			end
		end
	end
end
local function rhudManaUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "mana", value)
		for key,unitID in pairs(rhud.unitDB) do
			if unitID.mana and unitID.manaMax and unitID.rindex > 0 then 
				perc = throttle(unitID.old_mana, unitID.mana, unitID.manaMax, 1)
				if perc == true then
					if unitID.index == 1 then rhud.PlayerStat[5] = unitID.mana rhud.PlayerStat[6] = unitID.manaMax end
					if unitID.index == 1 or unitID.index == 2 then rhud.rstext[unitID.index]:SetText(tostring(unitID.mana)) end
					unitID.old_mana = unitID.mana
					rhud.fillarc(unitID.mana, unitID.manaMax, unitID.rindex)
					rhud.arctext[unitID.rindex]:SetText(string.format("%s", (math.ceil(unitID.mana/unitID.manaMax * 100))))
				end
			end
		end
	end
end
local function rhudManaMaxUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "manaMax", value)
		for key,unitID in pairs(rhud.unitDB) do
			if unitID.manaMax and unitID.rindex > 0 then 
				if unitID.index == 1 then rhud.PlayerStat[5] = unitID.mana rhud.PlayerStat[6] = unitID.manaMax end
				if unitID.index == 1 or unitID.index == 2 then rhud.rstext[unitID.index]:SetText(tostring(unitID.mana)) end
				rhud.fillarc(unitID.mana, unitID.manaMax, unitID.rindex)
				rhud.arctext[unitID.rindex]:SetText(string.format("%s", (math.ceil(unitID.mana/unitID.manaMax * 100))))
			end
		end
	end
end
local function rhudChargeUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "charge", value)
		unitID = rhud.unitDB["player"]
		if unitId == unitID.id then
			if unitID.charge and unitID.rindex > 0 then
				local maxcharge = unitID.chargeMax or 100
				perc = throttle(unitID.old_charge, unitID.charge, maxcharge, 2)
				if perc == true then
					unitID.old_charge = unitID.charge
					rhud.fillarc(unitID.charge, 100, 4)
					rhud.arctext[4]:SetText(string.format("%s", (unitID.charge)))
				end
			end
		end
	end
end
local function rhudChargeMaxUpdate(hEvent, details)
	for unitId,value in pairs(details) do rhud.AdjustTable(unitId, "chargeMax", value) end
end
local function rhudEnergyUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "energy", value)
		for key,unitID in pairs(rhud.unitDB) do
			if unitID.energy and unitID.energyMax and unitID.rindex > 0 then 
				perc = throttle(unitID.old_energy, unitID.energy, unitID.energyMax, 2)
				if perc == true then
					if unitID.index == 1 then rhud.PlayerStat[5] = unitID.energy rhud.PlayerStat[6] = unitID.energyMax end
					if unitID.index == 1 or unitID.index == 2 then rhud.rstext[unitID.index]:SetText(tostring(unitID.energy)) end
					unitID.old_energy = unitID.energy
					rhud.fillarc(unitID.energy, unitID.energyMax, unitID.rindex)
					rhud.arctext[unitID.rindex]:SetText(string.format("%s", (math.ceil(unitID.energy/unitID.energyMax * 100))))
				end
			end
		end
	end
end
local function rhudEnergyMaxUpdate(hEvent, details)
	for unitId,value in pairs(details) do rhud.AdjustTable(unitId, "energyMax", value) end
end
local function rhudComboUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "combo", value)
		unitID = rhud.unitDB["player"]
		if unitID.index == 1 then
			if unitID.combo ~= nil then
				if unitID.calling == "warrior" then
					rhud.combomask:SetWidth(rhud.OptionsUIElements[9]:GetWidth() / 3 * unitID.combo)
				end
				if unitID.calling == "rogue" then
					rhud.combomask:SetWidth(rhud.OptionsUIElements[9]:GetWidth() / 5 * unitID.combo)
				end
			end
		end
	end
end
local function rhudLevelUpdate()
	levelID = Inspect.Unit.Detail("player")
	if levelID and levelID.level ~= nil then
		rhud.OptionsUIElementsText[1]:SetText(tostring(levelID.level))
	end
end
local function rhudMarkUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "mark", value)
		
		unitID = rhud.unitDB["player.target"]
		if unitID and unitID.index == 2 then
			if unitID.mark then
				rhud.targetmarkicon:SetTexture("Rift", rhud.RaidMarkerImages[unitID.mark])
				rhud.targetmarkicon:SetVisible(true) else rhud.targetmarkicon:SetVisible(false)
			end
		end
	end
end
local function rhudPowerUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "power", value)
		for key,unitID in pairs(rhud.unitDB) do
			if unitID.power and unitID.rindex > 0 then 
				perc = throttle(unitID.old_power, unitID.power, 100, 2)
				if perc == true then
					if unitID.index == 1 then rhud.PlayerStat[5] = unitID.power rhud.PlayerStat[6] = 100 end
					if unitID.index == 1 or unitID.index == 2 then rhud.rstext[unitID.index]:SetText(tostring(unitID.power)) end
					unitID.old_power = unitID.power
					rhud.fillarc(unitID.power, 100, unitID.rindex)
					rhud.arctext[unitID.rindex]:SetText(string.format("%s", math.ceil(unitID.power)))
				end
			end
		end
	end
end
local function rhudPlanarUpdate(hEvent, details)
	for unitId,value in pairs(details) do rhud.AdjustTable(unitId, "planar", value)
		if rhud.unitDB["player"].index == 1 and rhudIconsDB[3].showicon == true then
			rhud.OptionsUIElementsText[3]:SetText(tostring(rhud.unitDB["player"].planar))
		end
	end
end
local function rhudPvpUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "pvp", value)
		if rhud.unitDB["player"].pvp == true and rhudIconsDB[5].showicon == true then
			rhud.OptionsUIElementsIcons[5]:SetVisible(true)	else rhud.OptionsUIElementsIcons[5]:SetVisible(false)
		end
		if rhud.unitDB["player.target"] and rhud.unitDB["player.target"].pvp == true and rhudIconsDB[17].showicon == true then
			rhud.targetpvpicon:SetVisible(true) else rhud.targetpvpicon:SetVisible(false)
		end
	end
end
local function rhudReadyUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "ready", value)
		if rhud.unitDB["player"].index == 1 and rhudIconsDB[6].showicon == true then
			v = rhud.unitDB["player"].ready
			if v == true then
				rhud.OptionsUIElementsIcons[6]:SetTexture("Rift", "raid_icon_ready.png.dds")
				rhud.OptionsUIElementsIcons[6]:SetVisible(true)
			elseif v == false then
				rhud.OptionsUIElementsIcons[6]:SetTexture("Rift", "raid_icon_notready.png.dds")
				rhud.OptionsUIElementsIcons[6]:SetVisible(true)
			else
				rhud.OptionsUIElementsIcons[6]:SetVisible(false)
			end
		end
	end
end
local function rhudRoleUpdate(hEvent, details)
	for unitId,value in pairs(details) do rhud.AdjustTable(unitId, "role", value) end
rhud.playerfull = false
rhud.convictionfound = nil
end
local function rhudRoleChanged(hEvent, details)    --Event.TEMPORARY.Role
rhud.playerfull = false
rhud.convictionfound = nil
end
local function rhudVitalityUpdate(hEvent, details)
	for unitId,value in pairs(details) do
		rhud.AdjustTable(unitId, "vitality", value)
		if rhud.unitDB["player"].index == 1 and rhudIconsDB[4].showicon == true then
			if rhud.unitDB["player"].vitality ~= nil and rhud.unitDB["player"].vitality < 100 then
				rhud.OptionsUIElementsText[4]:SetText(tostring(rhud.unitDB["player"].vitality))
				rhud.OptionsUIElementsIcons[4]:SetVisible(true)
				rhud.OptionsUIElementsText[4]:SetVisible(true)
			else
				rhud.OptionsUIElementsIcons[4]:SetVisible(false)
				rhud.OptionsUIElementsText[4]:SetVisible(false)
			end
		end
	end
end
local function rhudCastbarUpdate(hEvent, details)
	if rhudDataTable[11].enabled == false and rhudDataTable[12].enabled == false then return end
	for key,value in pairs(details) do
		if Inspect.Unit.Lookup(key) == "player" then
			if value == true then
				rhud.CastbarUpdated = true
			else
				rhud.arc[11]:SetVisible(false)
				rhud.arctext[11]:SetText("")
				rhud.fillarc(0, 100, 11)
				rhud.CastbarUpdated = false
			end
		end
		if Inspect.Unit.Lookup(key) == "player.target" then
			if value == true then
				rhud.CastbarUpdated = true
			else
				rhud.arc[12]:SetVisible(false)
				rhud.arctext[12]:SetText("")
				rhud.fillarc(0, 100, 12)
				rhud.CastbarUpdated = false
			end
		end
	end
end
function rhud.BuffsAdded(hEvent, id, buffs)
	if rhudIconsDB[15].showicon == false  and rhudIconsDB[16].showicon == false  then return end
	if id == rhud.unitBuffsID.player and id ~= rhud.unitBuffsID.target and rhudIconsDB[15].showicon == true then
		for buffspec, buffid in pairs(buffs) do
			detail = Inspect.Buff.Detail(id, buffspec)
			if (detail.debuff and detail.name ~= "Looking For Group") or (rhudSData.class == "cleric" and detail.name =="Conviction") then
				if detail.begin then begin = detail.begin else begin = Inspect.Time.Frame() end
				if detail.duration then dur = detail.duration else dur = 999 end
				rem = dur - (Inspect.Time.Frame() - begin)
				table.insert(rhud.unitBuffs,{bspec = buffspec, bpid = id, bbegin = begin, bid = buffspec, bname = detail.name, btime = rem, bstack = detail.stack, bdur = dur, bicon = detail.icon})
				table.sort(rhud.unitBuffs, function(a, b)
				if a.btime ~= b.btime then return a.btime > b.btime
				elseif a.bname ~= b.bname then return a.bname > b.bname
				end	end)
				if table.getn(rhud.unitBuffs) > rhud.pbuffrowmax then rhud.pbuffrowmax = table.getn(rhud.unitBuffs) end
				for i = 1, table.getn(rhud.unitBuffs) do
					local x = 0 local y = 0 local row = rhudSData.pbuffrow
					if rhud.pbuffimg[i] == nil then
						rhud.pbuffimg[i] = UI.CreateFrame("Texture", "BuffIcon"..i, rhud.Window)
						rhud.pbufftext[i] = UI.CreateFrame("Text", "BuffTimer"..i, rhud.Window)
						rhud.pbuffimg[i]:SetTexture(rhud.addonId, "Textures/blank.png")
						rhud.pbuffimg[i]:SetHeight(32)
						rhud.pbuffimg[i]:SetWidth(32)
						rhud.pbuffimg[i]:SetLayer(2)
						rhud.pbuffimg[i]:SetVisible(false)
						rhud.pbuffimg[i]:SetMouseMasking("limited")
						rhud.pbuffimg[i]:EventAttach(Event.UI.Input.Mouse.Cursor.In, function()	rhud.TooltipShow(2, i) end, "ShowTooltip" )
						rhud.pbuffimg[i]:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function() rhud.TooltipHide(2, i) end, "ShowTooltip" )
						rhud.pbufftext[i]:SetPoint("CENTER", rhud.pbuffimg[i], "CENTER") 
						rhud.pbufftext[i]:SetFontSize(14)
						rhud.pbufftext[i]:SetLayer(3)
						rhud.pbufftext[i]:SetEffectGlow(rhud.glowTable)
						rhud.pbufftext[i]:SetText("")
						for j = 1, i do
							rhud.pbuffimg[j]:SetPoint("TOPRIGHT", rhud.OptionsUIElements[15], "TOPRIGHT", -x * 40, y * 40) 
							x = x + 1
							if j > (row - 1) then row = row + rhudSData.pbuffrow x = 0 y = y + 1 end
						end
					end
					rhud.pbuffimg[i]:SetTexture("Rift", rhud.unitBuffs[i].bicon)
				end
----
				rhud.pbuffimg[table.getn(rhud.unitBuffs)]:SetVisible(true)
				rhud.playerhasbuffs = true
			end
		end
	end
	if id == rhud.unitBuffsID.target and id ~= rhud.unitBuffsID.player and rhudIconsDB[16].showicon == true then
		for buffspec, buffid in pairs(buffs) do
			detail = Inspect.Buff.Detail(id, buffspec)
			if detail.debuff then
				if detail.begin then begin = detail.begin else begin = Inspect.Time.Frame() end
				if detail.duration then dur = detail.duration else dur = 999 end
				rem = dur - (Inspect.Time.Frame() - begin)
				if rhudSData.misc[1] == true and (detail.caster == rhud.unitBuffsID.player or detail.caster == rhud.unitBuffsID.pet) then 
					table.insert(rhud.targetBuffs,{bspec = buffspec, bpid = id, bbegin = begin, bid = buffspec, bname = detail.name, btime = rem, bstack = detail.stack, bdur = dur, bicon = detail.icon})
				end
				if rhudSData.misc[1] == false then 
					table.insert(rhud.targetBuffs,{bspec = buffspec, bpid = id, bbegin = begin, bid = buffspec, bname = detail.name, btime = rem, bstack = detail.stack, bdur = dur, bicon = detail.icon})
				end
				table.sort(rhud.targetBuffs, function(a, b)
				if a.btime ~= b.btime then return a.btime > b.btime
				elseif a.bname ~= b.bname then return a.bname > b.bname
				end	end)
				if table.getn(rhud.targetBuffs) == 0 then return end
				if table.getn(rhud.targetBuffs) > rhud.tbuffrowmax then rhud.tbuffrowmax = table.getn(rhud.targetBuffs) end
				for i = 1, table.getn(rhud.targetBuffs) do
					local x = 0 local y = 0 local row = rhudSData.tbuffrow
					if rhud.buffimg[i] == nil then
						rhud.buffimg[i] = UI.CreateFrame("Texture", "BuffIcon"..i, rhud.Window)
						rhud.bufftext[i] = UI.CreateFrame("Text", "BuffTimer"..i, rhud.Window)
						rhud.buffimg[i]:SetTexture(rhud.addonId, "Textures/blank.png")
						rhud.buffimg[i]:SetHeight(32)
						rhud.buffimg[i]:SetWidth(32)
						rhud.buffimg[i]:SetLayer(2)
						rhud.buffimg[i]:SetVisible(false)
						rhud.buffimg[i]:SetMouseMasking("limited")
						rhud.buffimg[i]:EventAttach(Event.UI.Input.Mouse.Cursor.In, function()	rhud.TooltipShow(1, i) end, "ShowTooltip" )
						rhud.buffimg[i]:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function() rhud.TooltipHide(1, i) end, "ShowTooltip" )
						rhud.bufftext[i]:SetPoint("CENTER", rhud.buffimg[i], "CENTER") 
						rhud.bufftext[i]:SetFontSize(14)
						rhud.bufftext[i]:SetLayer(3)
						rhud.bufftext[i]:SetEffectGlow(rhud.glowTable)
						rhud.bufftext[i]:SetText("")
						for j = 1, i do
							rhud.buffimg[j]:SetPoint("TOPLEFT", rhud.OptionsUIElements[16], "TOPLEFT", x * 40, y * 40) 
							x = x + 1
							if j > (row - 1) then row = row + rhudSData.tbuffrow x = 0 y = y + 1 end
						end
					end
					rhud.buffimg[i]:SetTexture("Rift", rhud.targetBuffs[i].bicon)
				end
				rhud.buffimg[table.getn(rhud.targetBuffs)]:SetVisible(true)

				rhud.targethasbuffs = true
			end
		end
	end
end
function rhud.BuffsRemoved(hEvent, id, buffs)
	if id == rhud.unitBuffsID.player then
		for k, l in pairs (rhud.unitBuffs) do
			for g in pairs(buffs) do 
				if g == l.bspec then
					table.remove(rhud.unitBuffs, k)
					if rhudSData.class == "cleric" and l.bname == "Conviction" and rhud.convictionfound == true then
						rhud.fillarc(0, 100, 4) rhud.arctext[4]:SetText("0") rhud.convictionfound = false
					end
				end
			end
		end
		if table.getn(rhud.unitBuffs) < rhud.pbuffrowmax then
			for i = (table.getn(rhud.unitBuffs) + 1), rhud.pbuffrowmax do
					rhud.pbuffimg[i]:SetVisible(false)
					rhud.pbufftext[i]:SetText("")
			end
		end
	end
	if id == rhud.unitBuffsID.target then
		for k, l in pairs (rhud.targetBuffs) do
			for g in pairs(buffs) do 
				if g == l.bspec then table.remove(rhud.targetBuffs, k) end
			end
		end
		if table.getn(rhud.targetBuffs) < rhud.tbuffrowmax then
			for i = (table.getn(rhud.targetBuffs) + 1), rhud.tbuffrowmax do
					rhud.buffimg[i]:SetVisible(false)
					rhud.bufftext[i]:SetText("")
			end
		end
	end
end


Command.Event.Attach(Event.Unit.Detail.Absorb, rhudAbsorbUpdate, "Update_Absorb")
Command.Event.Attach(Event.Unit.Detail.Health, rhudHpUpdate, "Update_Health")
Command.Event.Attach(Event.Unit.Detail.HealthMax, rhudHpMaxUpdate, "Update_Max_Health")
Command.Event.Attach(Event.Unit.Detail.Mana, rhudManaUpdate, "Update_Mana")
Command.Event.Attach(Event.Unit.Detail.ManaMax, rhudManaMaxUpdate, "Update_Max_Mana")
Command.Event.Attach(Event.Unit.Detail.Charge, rhudChargeUpdate, "UpdateCharge")
Command.Event.Attach(Event.Unit.Detail.ChargeMax, rhudChargeMaxUpdate, "UpdateChargeMax")
Command.Event.Attach(Event.Unit.Detail.Energy, rhudEnergyUpdate, "UpdateEnergy")
Command.Event.Attach(Event.Unit.Detail.EnergyMax, rhudEnergyMaxUpdate, "UpdateEnergyMax")
Command.Event.Attach(Event.Unit.Detail.Combo, rhudComboUpdate, "UpdateCombo")
Command.Event.Attach(Event.Unit.Detail.Level, rhudLevelUpdate, "UpdateLevel")
Command.Event.Attach(Event.Unit.Detail.Mark, rhudMarkUpdate, "UpdateMark")
Command.Event.Attach(Event.Unit.Detail.Planar, rhudPlanarUpdate, "UpdatePlanar")
Command.Event.Attach(Event.Unit.Detail.Power, rhudPowerUpdate, "UpdatePower")
Command.Event.Attach(Event.Unit.Detail.Pvp, rhudPvpUpdate, "UpdatePvp")
Command.Event.Attach(Event.Unit.Detail.Ready, rhudReadyUpdate, "UpdateReadyCheck")
Command.Event.Attach(Event.Unit.Detail.Role, rhudRoleUpdate, "UpdateRole")
Command.Event.Attach(Event.Unit.Detail.Vitality, rhudVitalityUpdate, "VitalityPower")
Command.Event.Attach(Event.Unit.Castbar, rhudCastbarUpdate, "Castbar")
Command.Event.Attach(Event.Buff.Add, rhud.BuffsAdded, "BuffAdd")
Command.Event.Attach(Event.Buff.Remove, rhud.BuffsRemoved, "BuffRemove")
Command.Event.Attach(Event.TEMPORARY.Role, rhudRoleChanged, "roleChanged")
