local addon, rhud = ...

local lastUnitUpdate = 0
rhud.playerfull = false
local function getThrottle()
	local now = Inspect.Time.Frame()
	elapsed = now - lastUnitUpdate
	if (elapsed >= (.1)) then lastUnitUpdate = now return true end
end

function rhud.UnitUpdate()

	if rhudSData.islocked == false then return end
	timer = getThrottle()
	if not timer then return end
	if not rhudIconsDB then return end
	if rhud.playerfull == false then rhud.LoadPlayer() end
	if rhud.playerfull ~= true then return end
	for unitident, unitID in pairs(rhud.unitDB) do

		if unitID.availability == nil and unitID.unit ~= nil then rhud.BuildTable(unitID.unit) end
------------------------
		if unitident == "player" and rhudIconsDB[15].showicon == true and rhud.playerhasbuffs == true then
			if table.getn(rhud.unitBuffs) > 0 then
				for j, k in pairs(rhud.unitBuffs) do
					if j > 5 then break end
					remaining = k.bdur - (Inspect.Time.Frame() - k.bbegin)
					if k.bdur == 999 then
						remain = ""
					else
						remain = tostring(math.floor(remaining))
						if k.bstack and k.bstack > 0 then remain  = "(" ..tostring(k.bstack)..")\n"..remain end
					end
					if remaining > 0 then
						if k.bname == "Conviction" and rhudSData.class == "cleric" then
							rhud.convictionfound = true
							if rhud.convictions == nil then rhud.convictions = 4 end
							local detail = Inspect.Buff.Detail(k.bpid, k.bid)
							if not detail then break end
							if detail.stack == nil then k.bstack = 1 else k.bstack = detail.stack end
							if k.bstack > rhud.convictions then rhud.convictions = k.bstack end
							if rhudDataTable[4].enabled == true then rhud.arc[4]:SetVisible(true) end
							rhud.fillarc(k.bstack, rhud.convictions, 4)
							rhud.arctext[4]:SetText(tostring(k.bstack))
						end
						rhud.pbufftext[j]:SetText(remain)
					end
				end
			else
				rhud.playerhasbuffs = false
			end
		end
----------------------
		if unitident == "player.target" and rhudIconsDB[16].showicon == true and rhud.targethasbuffs == true then
			if table.getn(rhud.targetBuffs) > 0 then
				for j, k in pairs(rhud.targetBuffs) do
					remaining = k.bdur - (Inspect.Time.Frame() - k.bbegin)
					k.btime = remaining
					if k.bdur == 999 then
						remain = ""
					else
						remain = tostring(math.floor(remaining))
						if k.bstack and k.bstack > 0 then remain  = "(" ..tostring(k.bstack)..")\n"..remain end
					end
					if remaining > 0 then
						rhud.bufftext[j]:SetText(remain)
					end
				end
			else
				rhud.targethasbuffs = false
			end
		end
------------------------
		if rhud.CastbarUpdated == false and rhud.arc[11]:GetVisible() == true then rhud.arc[11]:SetVisible(false) rhud.arctext[11]:SetText("") end
		if rhud.CastbarUpdated == false and rhud.arc[12]:GetVisible() == true then rhud.arc[12]:SetVisible(false) rhud.arctext[12]:SetText("") end
				
						
		if unitident == "player" and rhudDataTable[11].enabled == true then
			if rhud.CastbarUpdated == true then
				local castdetail = Inspect.Unit.Castbar("player")
				if castdetail ~= nil then
					rhud.arc[11]:SetVisible(true)
					if castdetail.uninterruptible then
						for k = 1, 4 do
							rhudDataTable[11].color.fs[k] = rhudSData.castcol[3].fs[k]
							rhudDataTable[11].color.fe[k] = rhudSData.castcol[3].fe[k]
						end
					else
						for k = 1, 4 do
							rhudDataTable[11].color.fs[k] = rhudSData.castcol[2].fs[k]
							rhudDataTable[11].color.fe[k] = rhudSData.castcol[2].fe[k]
						end
					end
					if castdetail.abilityName ~= nil then rhud.arctext[11]:SetText(castdetail.abilityName) else rhud.arctext[11]:SetText("") end
					if castdetail.remaining ~= nil and castdetail.duration ~= nil then
						rhud.fillarc(castdetail.remaining, castdetail.duration, 11)
					end
				end
			end
		end
-------------------------------
		if unitident == "player.target" and rhudDataTable[12].enabled == true then
			if rhud.CastbarUpdated == true then
				local castdetail = Inspect.Unit.Castbar("player.target")
				if castdetail ~= nil then
					rhud.arc[12]:SetVisible(true)
					if castdetail.uninterruptible then
						for k = 1, 4 do
							rhudDataTable[12].color.fs[k] = rhudSData.castcol[3].fs[k]
							rhudDataTable[12].color.fe[k] = rhudSData.castcol[3].fe[k]
						end
					else
						for k = 1, 4 do
							rhudDataTable[12].color.fs[k] = rhudSData.castcol[2].fs[k]
							rhudDataTable[12].color.fe[k] = rhudSData.castcol[2].fe[k]
						end
					end
					rhud.arctext[12]:SetText(castdetail.abilityName)
					if castdetail.remaining ~= nil and castdetail.duration ~= nil then
						rhud.fillarc(castdetail.remaining, castdetail.duration, 12)
					end
				end
			end
		end
---------------------------
	end
	rhud.events = {}
	rhud.events.changed = false
end

function rhud.CombatEnter()
	rhudSData.isincombat = true
	if not rhudSData.islocked  or rhud.WindowOptions:GetVisible() == true then
		rhudSData.islocked = true
		rhud.Window:SetBackgroundColor(0, 0, 0, 0)
		rhud.WindowDrag:SetVisible(false)
		rhud.WindowOptions:SetVisible(false)
	end
	if rhudSData.misc[3] == true then rhud.targetnameback:SetVisible(true)	end
	if rhudSData.misc[4] == true then rhud.targettnameback:SetVisible(true) end
	if rhudDataTable[8].enabled == true then rhud.arc[8]:SetVisible(true) end
	if rhudDataTable[9].enabled == true then rhud.arc[9]:SetVisible(true) end
	if rhudIconsDB[7].showicon == true then rhud.OptionsUIElementsIcons[7]:SetVisible(true) end
	rhud.Window:SetAlpha(rhudSData.aic)
end
function rhud.CombatLeave()
	rhudSData.isincombat = false
	rhud.OptionsUIElementsIcons[7]:SetVisible(false)
	rhud.targetnameback:SetVisible(false)
	rhud.targettnameback:SetVisible(false)
	if rhudSData.misc[5] == false and rhud.unitDB["target"] == nil then rhud.arc[8]:SetVisible(rhudSData.misc[5]) rhud.arc[9]:SetVisible(rhudSData.misc[5]) end
	if rhud.unitBuffsID.target == nil then	rhud.Window:SetAlpha(rhudSData.aoc) else rhud.Window:SetAlpha(rhudSData.aoct) end
end
function rhud.loadSettings()
	rhud.Window:SetVisible(true)
	if rhudSData.locmainx == nil or rhudSData.locmainx == 0 then
		rhudSData.locmainx = ((UIParent:GetWidth() / 2) - 50)
		rhudSData.locmainy = ((UIParent:GetHeight() / 2))
	end
	rhud.WindowDrag:SetPoint("TOPLEFT", rhud.Context, "TOPLEFT", rhudSData.locmainx, rhudSData.locmainy)
	rhudSData.islocked = true
	rhudSData.isincombat = false
	if rhudSData.version == nil then rhudSData.version = 0 end
	if rhudSData.aoct == nil then rhudSData.aoct = .75 end
	if rhudSData.gap == nil then rhudSData.gap = 0 end
	if rhudSData.pbuffrow == nil then rhudSData.pbuffrow = 1 end
	if rhudSData.tbuffrow == nil then rhudSData.tbuffrow = 3 end
	if rhudIconsArcDB[18] == nil then rhudIconsArcDB[18] = {"Raid Marker Icon", showicon = true, secure = "normal", width = 40, font= 0, height = 40, layer = 1, x = 135, y = 0} end
	if rhudIconsOrbDB[18] == nil then rhudIconsOrbDB[18] = {"Raid Marker Icon", showicon = true, secure = "normal", width = 40, font= 0, height = 40, layer = 1, x = 115, y = 0} end
	if rhudIconsArcDB[19] == nil then rhudIconsArcDB[19] = {"Target Class/Type", showicon = true, secure = "normal", width = 270, font= 20, height = 40, layer = 1, x = 0, y = 240} end
	if rhudIconsOrbDB[19] == nil then rhudIconsOrbDB[19] = {"Target Class/Type", showicon = true, secure = "normal", width = 270, font= 20, height = 40, layer = 1, x = 0, y = 185} end
	rhudIconsArcDB[12][1] = "Target Name"
	rhudIconsOrbDB[12][1] = "Target Name"
	if rhudSData.size[rhudSData.skinval][3] == 1 then rhudDataTable = rhudArcTable rhudIconsDB = rhudIconsArcDB end
	if rhudSData.size[rhudSData.skinval][3] == 2 then rhudDataTable = rhudOrbTable rhudIconsDB = rhudIconsOrbDB end
	if rhudSData.version ~= rhud.addondetail.toc.Version then
		if string.find(rhud.addondetail.toc.Version, "_c") then
			rhud.cprint ("Resetting All Saved Settings", "red")
			rhud.forcereset = true
			rhud.SetSavedValues()
			rhudSData.locmainx = ((UIParent:GetRight() / 2) - 50)
			rhudSData.locmainy = ((UIParent:GetBottom() / 2))
			rhud.WindowDrag:SetPoint("TOPLEFT", rhud.Context, "TOPLEFT", rhudSData.locmainx, rhudSData.locmainy)
		end
	end
	rhud.setmatrix()
	rhud.path = rhud.setpath[rhudSData.skinval]
	rhud.stroke = { r = rhudSData.borderc[1], g = rhudSData.borderc[2], b = rhudSData.borderc[3], a = rhudSData.borderc[4], thickness = rhudSData.border, cap = "round"}
	rhud.createWindow()
	rhud.createWindowEvents()
	rhud.LoadPlayer()
	rhud.addondetail = Inspect.Addon.Detail("RiftHud")
	if rhudSData.version ~= rhud.addondetail.toc.Version then
		rhudSData.version = rhud.addondetail.toc.Version
		if string.find(rhud.addondetail.toc.Version, "_a") or string.find(rhud.addondetail.toc.Version, "_c") then
			print ("Resetting Account Profile for " .. rhud.unitDB["player"].name)
			for k, v in pairs(rhudProfilesDB) do
				if k then
					if v[1].version and v[1].version ~= rhud.addondetail.toc.Version then
						rhudProfilesDB[k] = nil
					end
				end
			end
			rhudProfilesDB[rhud.unitDB["player"].name] = {}
			rhud.profileSave(rhud.unitDB["player"].name)
		end
	end
	rhud.createOptions()
	rhud.createOptionsTabA()
	rhud.createOptionsTabB()
	rhud.createOptionsTabC()
	rhud.createOptionsTabD()
	rhud.createOptionsTabE()
	rhud.settingloaded = true
	LibVersionCheck.register(rhud.addondetail.toc.Identifier, rhud.addondetail.toc.Version)
end

function rhud.SlashCommand(hEvent, params)
	if params == "reset" and rhudSData.isincombat == false then
		rhud.settingloaded = false
		rhud.SetSavedValues()
		rhudSData.locmainx = ((UIParent:GetRight() / 2) - 50)
		rhudSData.locmainy = ((UIParent:GetBottom() / 2))
		rhud.WindowDrag:SetPoint("TOPLEFT", rhud.Context, "TOPLEFT", rhudSData.locmainx, rhudSData.locmainy)
		rhud.Window:SetBackgroundColor(0, 0, 0, 0)
		rhud.createWindow()
		rhud.LoadPlayer()
		rhud.settingloaded = true

	elseif params == "config" and rhudSData.isincombat == false then
		rhud.toggleConfig()
	elseif params == "help" and rhudSData.isincombat == false then
		print ("---------------------------")
		print ("RiftHud Help Menu")
		print ("---------------------------")
		print ("/rhud          -- Toggle Drag Window")
		print ("/rhud config   -- Open Configuration window")
		print ("/rhud reset    -- Reset default addon settings")
	else
		if rhudSData.isincombat == false then
			if rhudSData.islocked == true then
				rhudSData.islocked = false
				rhud.Window:SetBackgroundColor(.60, 1, 1, .2)
				rhud.WindowDrag:SetVisible(true)
			else
				rhudSData.islocked = true
				rhud.Window:SetBackgroundColor(0, 0, 0, 0)
				rhud.WindowDrag:SetVisible(false)
			end
		end
	end
end
function rhud.SetSavedValues()
rhudDataTable = {}
rhudIconsDB = {}
rhudSData = {}
rhudSData = {version = 0, locmainx = 0, locmainy = 0, aic = 1, aoc = .6, aoct = .75, gap = 0, islocked = true, isincombat = false, skin = "Rounded", skinval = 1, class = "mage",
	pcol = { {fs= {.5, .5, 0, 1}, fe = {.86, .8, 0, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {.5, 0, .5, 1}, fe = {.86, 0, .86, 1}} },
	fcol = { {fs= {.5, .5, 0, 1}, fe = {.86, .8, 0, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {.5, 0, .5, 1}, fe = {.86, 0, .86, 1}} },
	tcol = { {fs= {.5, .5, 0, 1}, fe = {.86, .8, 0, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {0, .2, .6, 1}, fe = {0, .4, .8, 1}}, {fs= {.5, 0, .5, 1}, fe = {.86, 0, .86, 1}} },
	castcol = { {fs = {0, .42, .87, 1}, fe = {0, .75, .75, 1}}, {fs = {0, .42, .87, 1}, fe = {0, .75, .75, 1}}, {fs= {.5, .5, 0, 1}, fe = {.86, .8, 0, 1}} },
	backc = {0, 0, 0, .2}, border = 1, borderc = {.7, .7, .7, .5},
	size = { {{w = 60, h = 256}, {w = 256, h = 60}, 1}, {{w = 60, h = 256}, {w = 256, h = 60}, 1}, {{w = 80, h = 256}, {w = 256, h = 80}, 1}, {{w = 100, h = 100}, {w = 100, h = 100}, 2} },
	misc = {true, true, true, true, true, true, true, true, true, true}, pbuffrow = 1, tbuffrow = 3}
rhudIconsArcDB = {}
rhudIconsArcDB = {
	{"Level Icon", 					showicon = true, secure = "restricted", width = 40, 	font= 20, height = 40, 	layer = 3, x = -225, 	y = 200},	--1
	{"Role Icon", 					showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 3, x = -185, 	y = 200},	--2
	{"Planar Icon", 				showicon = true, secure = "normal", 	width = 40, 	font= 20, height = 40, 	layer = 3, x = 225, 	y = 200},	--3
	{"Vitality Icon", 				showicon = true, secure = "normal", 	width = 40, 	font= 20, height = 40, 	layer = 3, x = 185, 	y = 200},	--4
	{"PvP Icon", 					showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = -270, 	y = 200},	--5
	{"ReadyCheck Icon", 			showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = -270, 	y = -135},	--6
	{"Combat Icon", 				showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = -225, 	y = -135},	--7
	{"Target Difficulty Icon", 		showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = 140, 	y = -150},	--8
	{"Combo Points", 				showicon = true, secure = "normal", 	width = 150, 	font= 0, height = 30, 	layer = 1, x = 0, 		y = 150},	--9
	{"Player Health/Res Values", 	showicon = true, secure = "normal", 	width = 75, 	font= 16, height = 45, 	layer = 1, x = -175, 	y = -180},	--10
	{"Target Health/Res Values", 	showicon = true, secure = "normal", 	width = 75, 	font= 16, height = 45, 	layer = 1, x = 175, 	y = -180},	--11
	{"Target Name",			 		showicon = true, secure = "normal", 	width = 270, 	font= 24, height = 60, 	layer = 1, x = 0, 		y = 200},	--12
	{"Target of Target Name", 		showicon = true, secure = "normal",		width = 270, 	font= 20, height = 30, 	layer = 1, x = 0, 		y = 260},	--13
	{"Player Name", 				showicon = false, secure = "normal", 	width = 300, 	font= 30, height = 60, 	layer = 1, x = 0, 		y = 145},	--14
	{"Player Debuffs", 				showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = -290, 	y = -50},		--15
	{"Target Debuffs", 				showicon = true, secure = "normal", 	width = 120, 	font= 0, height = 40, 	layer = 1, x = 320, 	y = -50},		--16
	{"Target PvP Icon", 			showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = 120, 	y = -85},	--17
	{"Raid Marker Icon", 			showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = 135, 	y = 0},	--18
	{"Target Class/Type", 			showicon = true, secure = "normal", 	width = 270, 	font= 20, height = 40, layer = 1,  x = 0, 		y = 240}
}
rhudIconsOrbDB = {}
rhudIconsOrbDB = {
	{"Level Icon", 					showicon = true, secure = "restricted", width = 40, 	font= 20, height = 40, 	layer = 3, x = -225, 	y = 150},	--1
	{"Role Icon", 					showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 3, x = -185, 	y = 150},	--2
	{"Planar Icon", 				showicon = true, secure = "normal", 	width = 40, 	font= 20, height = 40, 	layer = 3, x = 225, 	y = 150},	--3
	{"Vitality Icon", 				showicon = true, secure = "normal", 	width = 40, 	font= 20, height = 40, 	layer = 3, x = 185, 	y = 150},	--4
	{"PvP Icon", 					showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = -270, 	y = 150},	--5
	{"ReadyCheck Icon", 			showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = -300,	y = -80},	--6
	{"Combat Icon", 				showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = -250, 	y = -80},	--7
	{"Target Difficulty Icon", 		showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = 135, 	y = -60},	--8
	{"Combo Points", 				showicon = true, secure = "normal", 	width = 150, 	font= 0, height = 30, 	layer = 1, x = 0, 		y = 115},	--9
	{"Player Health/Res Values", 	showicon = true, secure = "normal", 	width = 75, 	font= 16, height = 45, 	layer = 1, x = -200, 	y = 0},	--10
	{"Target Health/Res Values", 	showicon = true, secure = "normal", 	width = 75, 	font= 16, height = 45, 	layer = 1, x = 200, 	y = 0},	--11
	{"Target Name", 				showicon = true, secure = "normal", 	width = 270, 	font= 24, height = 60, 	layer = 1, x = 0, 		y = 165},	--12
	{"Target of Target Name", 		showicon = true, secure = "normal",		width = 270, 	font= 20, height = 30, 	layer = 1, x = 0, 		y = 220},	--13
	{"Player Name", 				showicon = false, secure = "normal", 	width = 300, 	font= 30, height = 60, 	layer = 1, x = 0, 		y = -45},	--14
	{"Player Debuffs", 				showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = -290, 	y = -50},		--15
	{"Target Debuffs", 				showicon = true, secure = "normal", 	width = 120, 	font= 0, height = 40, 	layer = 1, x = 320, 	y = -50},		--16
	{"Target PvP Icon", 			showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = 200, 	y = -55},	--17
	{"Raid Marker Icon", 			showicon = true, secure = "normal", 	width = 40, 	font= 0, height = 40, 	layer = 1, x = 115, 	y = 0},	--18
	{"Target Class/Type", 			showicon = true, secure = "normal", 	width = 270, 	font= 20, height = 40, 	layer = 3, x = 0,		y = 185}
}
rhudArcTable = {}
rhudArcTable = {
	{"Player Absorb", "Absorb Percent", 				enabled = true, color = {fs = {0, .42, .87, 1}, 	fe = {0, .75, .75, 1},	}, 	pos = 1, growth = 4, scale = {w = 80, h = 80}, 	scaledim = 1, x = -240, y = 0, 		showicon = true, font = 12, fontc = {1, 1, 1}, tw = 40, 	th = 24, tx = 0, 	ty = 140},	--1
	{"Player Health", "Player Health Percent", 			enabled = true, color = {fs = {.08, .25, 0, 1},		fe = {.5, 1, 0, 1},		}, 	pos = 1, growth = 4, scale = {w = 100, h = 100}, 	scaledim = 1, x = -200,	y = 0, 		showicon = true, font = 14, fontc = {1, 1, 1}, tw = 40, 	th = 24, tx = 20, 	ty = 170},	--2
	{"Player Resource", "Player Resource Percent", 		enabled = true, color = {fs = {0, 1, 1, 1}, 		fe = {.5, 1, 0, 1}, 	}, 	pos = 1, growth = 4, scale = {w = 100, h = 100}, 	scaledim = 1, x = -170,	y = 0, 		showicon = true, font = 14, fontc = {1, 1, 1}, tw = 40, 	th = 24, tx = 20, 	ty = 170},	--3
	{"Charge/Conviction Values", "Charge/Conviction", 	enabled = true, color = {fs = {.25, 0, 0, 1}, 		fe = {1, 0, 1, 1}, 		}, 	pos = 1, growth = 4, scale = {w = 80, h = 80}, 	scaledim = 1, x = -140, y = 0, 		showicon = true, font = 12, fontc = {1, 1, 1}, tw = 40, 	th = 24, tx = 30, 	ty = 140},	--4
	{"Pet Health", "Pet Health Percent", 				enabled = true, color = {fs = {.37, 0, 0, 1}, 		fe = {1, 0, 0, 1},		}, 	pos = 1, growth = 4, scale = {w = 80, h = 80}, 	scaledim = 1, x = -120, y = 0,		showicon = true, font = 12, fontc = {1, 1, 1}, tw = 40,		th = 24, tx = 30, 	ty = 140},	--5
	{"Focus Health", "Focus Health Percent", 			enabled = true, color = {fs = {.10, 0.62, 0, 1}, 	fe = {.30, 1, 0, 1},	},	pos = 3, growth = 4, scale = {w = 80, h = 80}, 	scaledim = 1, x = 120, 	y = 0,		showicon = true, font = 12,	fontc = {1, 1, 1}, tw = 40, 	th = 24, tx = -30,	ty = 140},	--6
	{"Focus Resource", "Focus Resource Percent", 		enabled = true, color = {fs = {0, 1, 1, 1}, 		fe = {.5, 1, 0, 1},		},	pos = 3, growth = 4, scale = {w = 80, h = 80}, 	scaledim = 1, x = 140, 	y = 0, 		showicon = true, font = 12,	fontc = {1, 1, 1}, tw = 40,		th = 24, tx = -30, 	ty = 140},	--7
	{"Target Health", "Target Health Percent", 			enabled = true, color = {fs = {.10, .62, 0, 1}, 	fe = {.30, 1, 0, 1},	}, 	pos = 3, growth = 4, scale = {w = 100, h = 100}, 	scaledim = 1, x = 165, 	y = 0, 		showicon = true, font = 12, fontc = {1, 1, 1}, tw = 40, 	th = 24, tx = -20, 	ty = 170},	--8
	{"Target Resource", "Target Resource Percent", 		enabled = true, color = {fs = {0, 1, 1, 1}, 		fe = {.5, 1, 0, 1},		}, 	pos = 3, growth = 4, scale = {w = 100, h = 100}, 	scaledim = 1, x = 200, 	y = 0, 		showicon = true, font = 12, fontc = {1, 1, 1}, tw = 40, 	th = 24, tx = -20, 	ty = 170},	--9
	{"Target of Target", "Target of Target Percent", 	enabled = true, color = {fs = {.5, .1, 0, 1}, 		fe = {1, .20, 0, 1},	}, 	pos = 3, growth = 4, scale = {w = 80, h = 80}, 	scaledim = 1, x = 240, 	y = 0, 		showicon = true, font = 12, fontc = {1, 1, 1}, tw = 40, 	th = 24, tx = 0, 	ty = 140},	--10
	{"Player Castbar", "Player Castbar Name", 			enabled = true, color = {fs = {0, .42, .87, 1}, 	fe = {0, .75, .75, 1},	}, 	pos = 2, growth = 1, scale = {w = 100, h = 100}, 	scaledim = 2, x = 0, 	y = -150, 	showicon = true, font = 20, fontc = {1, 1, 1}, tw = 200, 	th = 40, tx = 0, 	ty = 20},	--11
	{"Target Castbar", "Target Castbar Name", 			enabled = true, color = {fs = {0, .42, .87, 1}, 	fe = {0, .75, .75, 1}, 	}, 	pos = 2, growth = 1, scale = {w = 100, h = 100}, 	scaledim = 2, x = 0, 	y = -200, 	showicon = true, font = 20, fontc = {1, 1, 1}, tw = 200, 	th = 40, tx = 0, 	ty = 40},	--12
}
rhudOrbTable = {}
rhudOrbTable = {
	{"Player Absorb", "Absorb Percent", 				enabled = true, color = {fs = {0, .42, .87, 1}, 	fe = {0, .75, .75, 1},	}, 	pos = 3, growth = 4, scale = {w = 140, h = 140}, 	side = 1, scaledim = 1, x = -200, 	y = 0, 		showicon = true, font = 12, fontc = {0, 1, 1}, 		tw = 40, 	th = 24, tx = -85, 	ty = 0},	--1
	{"Player Health", "Player Health Percent", 			enabled = true, color = {fs = {.10, 0.62, 0, 1},	fe = {.30, 1, 0, 1},	}, 	pos = 1, growth = 4, scale = {w = 100, h = 100}, 	side = 1, scaledim = 1, x = -200,	y = 0, 		showicon = true, font = 14, fontc = {.5, 1, 0}, 	tw = 40, 	th = 24, tx = 0, 	ty = 90},	--2
	{"Player Resource", "Player Resource Percent", 		enabled = true, color = {fs = {0, 1, 1, 1}, 		fe = {.5, 1, 0, 1}, 	}, 	pos = 2, growth = 4, scale = {w = 120, h = 120}, 	side = 1, scaledim = 1, x = -200,	y = 0, 		showicon = true, font = 14, fontc = {0, .5, 1}, 	tw = 40, 	th = 24, tx = 0, 	ty = -80},	--3
	{"Charge/Conviction Values", "Charge/Conviction", 	enabled = true, color = {fs = {0, 1, 1, 1}, 		fe = {.5, 1, 0, 1}, 	}, 	pos = 3, growth = 4, scale = {w = 140, h = 140}, 	side = 2, scaledim = 1, x = -200, 	y = 0, 		showicon = true, font = 12, fontc = {1, 0, 1}, 		tw = 40, 	th = 24, tx = 80, 	ty = 0},	--4
	{"Pet Health", "Pet Health Percent", 				enabled = true, color = {fs = {.5, 0, 0, 1}, 		fe = {.87, .16, 0, 1},	}, 	pos = 1, growth = 4, scale = {w = 40, h = 40}, 	side = 1, scaledim = 1, x = -120,	y = 40,		showicon = true, font = 12, fontc = {1, 1, 0}, 		tw = 40,	th = 24, tx = 0, 	ty = 0},	--5
	{"Focus Health", "Focus Health Percent", 			enabled = true, color = {fs = {.10, 0.62, 0, 1}, 	fe = {.30, 1, 0, 1},	},	pos = 1, growth = 4, scale = {w = 50, h = 50}, 	side = 1, scaledim = 1, x = 275, 	y = 65,		showicon = true, font = 12,	fontc = {.65, 1, 0}, 	tw = 40, 	th = 24, tx = 50,	ty = -10},	--6
	{"Focus Resource", "Focus Resource Percent", 		enabled = true, color = {fs = {0, 1, 1, 1}, 		fe = {.5, 1, 0, 1},		},	pos = 2, growth = 4, scale = {w = 70, h = 70}, 	side = 1, scaledim = 1, x = 275, 	y = 65, 	showicon = true, font = 12,	fontc = {0, .65, 1}, 	tw = 40,	th = 24, tx = 50, 	ty = 10},	--7
	{"Target Health", "Target Health Percent", 			enabled = true, color = {fs = {.10, .62, 0, 1}, 	fe = {.30, 1, 0, 1},	}, 	pos = 1, growth = 4, scale = {w = 100, h = 100}, 	side = 1, scaledim = 1, x = 200, 	y = 0, 		showicon = true, font = 12, fontc = {.5, 1, 0}, 	tw = 40, 	th = 24, tx = 0, 	ty = 95},	--8
	{"Target Resource", "Target Resource Percent", 		enabled = true, color = {fs = {0, 1, 1, 1}, 		fe = {.5, 1, 0, 1},		}, 	pos = 2, growth = 4, scale = {w = 120, h = 120}, 	side = 1, scaledim = 1, x = 200, 	y = 0, 		showicon = true, font = 12, fontc = {0, .5, 1}, 	tw = 40, 	th = 24, tx = 0, 	ty = -80},	--9
	{"Target of Target", "Target of Target Percent", 	enabled = true, color = {fs = {.5, .1, 0, 1}, 		fe = {1, .20, 0, 1},	}, 	pos = 1, growth = 4, scale = {w = 40, h = 40}, 	side = 1, scaledim = 1, x = 120, 	y = 40, 	showicon = true, font = 12, fontc = {1, 1, 0}, 		tw = 40, 	th = 24, tx = 0, 	ty = 0},	--10
	{"Player Castbar", "Player Castbar Name", 			enabled = true, color = {fs = {0, .42, .87, 1}, 	fe = {0, .75, .75, 1},	}, 	pos = 4, growth = 1, scale = {w = 160, h = 160}, 	side = 1, scaledim = 1, x = -200, 	y = 0, 		showicon = true, font = 20, fontc = {0, 1, 1}, 		tw = 200, 	th = 40, tx = 0, 	ty = -95},	--11
	{"Target Castbar", "Target Castbar Name", 			enabled = true, color = {fs = {0, .42, .87, 1}, 	fe = {0, .75, .75, 1}, 	}, 	pos = 4, growth = 1, scale = {w = 140, h = 140}, 	side = 1, scaledim = 1, x = 200, 	y = 0, 		showicon = true, font = 20, fontc = {1, .65, 0}, 	tw = 200, 	th = 40, tx = 0, 	ty = -95},	--12
}
	if rhudSData.size[rhudSData.skinval][3] == 1 then rhudDataTable = rhudArcTable rhudIconsDB = rhudIconsArcDB	end
	if rhudSData.size[rhudSData.skinval][3] == 2 then rhudDataTable = rhudOrbTable rhudIconsDB = rhudIconsOrbDB end
	rhud.setmatrix()
	rhud.path = rhud.setpath[rhudSData.skinval]
	Command.Console.Display("general", false, "<font color='#FFFF00'>*****RiftHud settings have been reset to default values*****</font>", true)
	if rhud.forcereset == false then
		rhud.dprint("Reset called by User")
		rhudSData.version = rhud.addondetail.toc.Version
		rhud.createOptionsTabA()	
		rhud.createOptionsTabB()	
		rhud.createOptionsTabC()	
		rhud.createOptionsTabD()
	end
	rhud.forcereset = false 	
end
function rhud.LoadSavedVars(ident)
	rhud.addondetail = Inspect.Addon.Detail("RiftHud")

	if rhudSData == nil then rhud.SetSavedValues() end
	if rhudProfilesDB == nil then rhudProfilesDB = {} end
	if type(rhudArcTable[1].scale) == "number" then
		Command.Console.Display("general", false, "<font color='#FFFF00'>*****Due to changes in new scaling methods:*****</font>", true)
		rhud.SetSavedValues()
	end
end
function rhud.SaveSavedVars(h, addonidentifier)
	if addonidentifier == "RiftHud" then rhud.profileSave(rhud.unitDB["player"].name) end
end
Command.Event.Attach(Command.Slash.Register("rhud"), rhud.SlashCommand, "rhud.SlashCommand")
Command.Event.Attach(Event.Addon.Startup.End, rhud.loadSettings, "rhud.loadSettings")
Command.Event.Attach(Event.System.Secure.Enter, rhud.CombatEnter, "rhud.CombatEnter")
Command.Event.Attach(Event.System.Secure.Leave, rhud.CombatLeave, "rhud.CombatLeave")
Command.Event.Attach(Event.System.Update.Begin, rhud.UnitUpdate,  "UpdateHudDetails")
Command.Event.Attach(Library.LibUnitChange.Register("player.target"), rhud.PlayerTargetChange, "PlayerTargetChange")
Command.Event.Attach(Library.LibUnitChange.Register("player.pet"), rhud.PlayerPetChange, "PlayerPetChange")
Command.Event.Attach(Library.LibUnitChange.Register("focus"), rhud.PlayerFocusChange, "PlayerFocusChange")
Command.Event.Attach(Library.LibUnitChange.Register("player.target.target"), rhud.TargetTargetChange, "PlayerTargetTargetChange")
Command.Event.Attach(Event.Addon.SavedVariables.Load.End, rhud.LoadSavedVars, "rhud.LoadSavedVars")
Command.Event.Attach(Event.Addon.SavedVariables.Save.Begin, rhud.SaveSavedVars, "rhud.SaveSavedVars")

