local addon, rhud = ...

function rhud.BuildTable(unit)
	local details = Inspect.Unit.Detail(unit)
	if details ~= nil then 
		for k,v in pairs(details) do
			rhud.unitDB[unit][k] = v
		end 
	end
end
function rhud.LoadPlayer()
	local id = Inspect.Unit.Lookup("player")
	rhud.unitDB["player"] = {unit = "player", index = 1, hindex = 2, rindex = 3}
	rhud.BuildTable("player")
	local playerID = rhud.unitDB["player"]
	if rhudSData.isincombat == true and rhudDataTable[7].showicon == true then
		rhud.OptionsUIElementsIcons[7]:SetVisible(true)
	else
		rhud.OptionsUIElementsIcons[7]:SetVisible(false)
	end
	if playerID.availability ~= "full" then
	else
		if rhudProfilesDB[playerID.name] == nil then rhudProfilesDB[playerID.name] = {} end
		if table.getn(rhudProfilesDB[playerID.name]) == 0 then
			rhud.profileSave(playerID.name)
			rhud.buildplayerselectlist()
		end
		rhud.unitBuffsID.player = playerID.id
		rhud.OptionsUIElementsText[5]:SetText(playerID.name)
		rhud.OptionsUIElementsText[5]:SetVisible(rhudIconsDB[14].showicon)
		for i = 1, 4 do
			if playerID.calling == rhud.Calling[i] then
				rhudSData.class = playerID.calling
				rhudDataTable[3].color.fs = rhudSData.pcol[i].fs
				rhudDataTable[3].color.fe = rhudSData.pcol[i].fe
			end
			rhud.fillarc(0, 100, 3)
		end
		rhud.OptionsUIElementsText[1]:SetText(tostring(playerID.level))
		rhud.hptext[1]:SetText(tostring(playerID.health))
		rhud.hptext[1]:SetFontColor(0, 1, 0)

		rhud.arc[1]:SetVisible(rhudDataTable[1].enabled)
		rhud.arc[4]:SetVisible(false)
		if playerID.combo ~= nil then
			if playerID.calling == "rogue" then
			rhud.PlayerStat[4] = "Energy"
			rhud.combo:SetTexture(rhud.addonId, "Textures/combor.png")
			rhud.combomask:SetWidth(rhud.OptionsUIElements[9]:GetWidth() / 5 * playerID.combo)
			rhud.rstext[1]:SetText(tostring(playerID.energy))
			rhud.rstext[1]:SetFontColor(1, 0, 1)
			rhud.fillarc(playerID.energy, playerID.energyMax, 3)
			rhud.arctext[playerID.rindex]:SetText(string.format("%s", (math.ceil(playerID.energy/playerID.energyMax * 100))))
			end
			if playerID.calling == "warrior" then
			rhud.PlayerStat[4] = "Power"
			rhud.combo:SetTexture(rhud.addonId, "Textures/combow.png")
			rhud.combomask:SetWidth(rhud.OptionsUIElements[9]:GetWidth() / 3 * playerID.combo)
			rhud.rstext[1]:SetText(tostring(playerID.power))
			rhud.rstext[1]:SetFontColor(1, 1, 0)
			rhud.fillarc(playerID.power, 100, 3)
			rhud.arctext[playerID.rindex]:SetText(string.format("%s", (math.ceil(playerID.power))))
			end
		end
		if playerID.calling == "cleric" then
			rhud.rstext[1]:SetText(tostring(playerID.mana))
			rhud.rstext[1]:SetFontColor(0, .5, 1)
			rhud.fillarc(playerID.mana, playerID.manaMax, 3)
			rhud.arctext[playerID.rindex]:SetText(string.format("%s", (math.ceil(playerID.mana/playerID.manaMax * 100))))
			if rhud.convictionfound == true then
				if rhudDataTable[4].enabled == true then rhud.arc[4]:SetVisible(true) end
				rhud.arctext[4]:SetText("")
				rhud.fillarc(0, 100, 4)
			end
		end
		if playerID.calling == "mage" then
			rhud.arc[4]:SetVisible(true)
			chargetick = playerID.charge
			chargepercent = string.format("%s", chargetick)
			rhud.arctext[4]:SetText(chargepercent)
			rhud.fillarc(chargetick, 100, 4)
			rhud.rstext[1]:SetText(tostring(playerID.mana))
			rhud.rstext[1]:SetFontColor(0, .5, 1)
			rhud.fillarc(playerID.mana, playerID.manaMax, 3)
			rhud.arctext[playerID.rindex]:SetText(string.format("%s", (math.ceil(playerID.mana/playerID.manaMax * 100))))
		end
		if playerID.role ~= nil then
				rhud.OptionsUIElementsIcons[2]:SetTexture("RiftHud", "Textures/" .. playerID.role .. ".png")
		end
		if playerID.pvp == true and rhudIconsDB[5].showicon == true then rhud.OptionsUIElementsIcons[5]:SetVisible(true) else rhud.OptionsUIElementsIcons[5]:SetVisible(false) end
		if playerID.ready ~= nil and rhudIconsDB[6].showicon == true then rhud.OptionsUIElementsIcons[6]:SetVisible(true) else rhud.OptionsUIElementsIcons[6]:SetVisible(false) end
		if playerID.planar and rhudIconsDB[3].showicon == true then rhud.OptionsUIElementsText[3]:SetText(tostring(playerID.planar)) end
		if playerID.vitality and rhudIconsDB[4].showicon == true then
			if playerID.vitality ~= nil and playerID.vitality < 100 then
				rhud.OptionsUIElementsText[4]:SetText(tostring(playerID.vitality))
				rhud.OptionsUIElementsIcons[4]:SetVisible(true)
				rhud.OptionsUIElementsText[4]:SetVisible(true)
			else
				rhud.OptionsUIElementsIcons[4]:SetVisible(false)
				rhud.OptionsUIElementsText[4]:SetVisible(false)
			end
		end
	
		if Inspect.Unit.Lookup("player.target") then
			rhud.PlayerTargetChange(nil,true)
		end
		if Inspect.Unit.Lookup("player.pet") and rhudDataTable[5].enabled == true then
			rhud.PlayerPetChange(nil, true)
			rhud.arc[5]:SetVisible(true)
		else
			rhud.arc[5]:SetVisible(false)
		end
		if Inspect.Unit.Lookup("focus") then
			rhud.PlayerFocusChange(nil, true)
			if rhudDataTable[6].enabled == true then rhud.arc[6]:SetVisible(true) end
			if rhudDataTable[7].enabled == true then rhud.arc[7]:SetVisible(true) end
		else
			rhud.arc[6]:SetVisible(false)
			rhud.arc[7]:SetVisible(false)
		end
		if Inspect.Unit.Lookup("player.target.target") and rhudDataTable[10].enabled == true then
			rhud.TargetTargetChange{nil, true}
			rhud.arc[10]:SetVisible(true)
		else
			rhud.arc[10]:SetVisible(false)
		end
		rhud.fillarc(playerID.health, playerID.healthMax, 2)
		rhud.arctext[playerID.hindex]:SetText(string.format("%s", (math.ceil(playerID.health/playerID.healthMax * 100))))
		if (playerID.absorb == nil or playerID.absorb == false) then 
			rhud.PlayerStat[8] = 0
			rhud.arctext[1]:SetText("0")
			rhud.fillarc(0, 100, 1)
		elseif playerID.absorb ~= nil and playerID.healthMax ~= nil then
			rhud.PlayerStat[8] = playerID.absorb
			if playerID.absorb > playerID.healthMax then playerID.absorb = playerID.healthMax end
			rhud.arctext[1]:SetText(string.format("%s", (math.ceil(playerID.absorb/playerID.healthMax * 100))))
			rhud.fillarc(playerID.absorb, playerID.healthMax, 1)
		end

		rhud.arc[11]:SetVisible(false)
		rhud.CastbarUpdated = false
		rhud.playerfull = true
	end
end
function rhud.PlayerTargetChange(hEvent,targetID)
	if targetID then
		rhud.unitBuffsID.target = targetID
		rhud.unitDB["player.target"] = {unit = "player.target", index = 2, hindex = 8, rindex = 9}
		rhud.BuildTable("player.target")
		local unitID = rhud.unitDB["player.target"]
		if rhudSData.misc[3] == true and rhudSData.isincombat == false then rhud.targetnameback:SetVisible(true)	end
		if rhudDataTable[8].enabled == true then rhud.arc[8]:SetVisible(true) end
		if rhudDataTable[9].enabled == true then rhud.arc[9]:SetVisible(true) end
		if rhudSData.isincombat == false then rhud.Window:SetAlpha(rhudSData.aoct) end
		for a = 1, rhud.tbuffrowmax do
			rhud.bufftext[a]:SetText("")
			rhud.buffimg[a]:SetVisible(false)
		end
		local callingname
		if unitID.calling then
			for i = 1, 4 do
				if unitID.calling == rhud.Calling[i] then
					for k = 1, 4 do
						rhudDataTable[9].color.fs[k] = rhudSData.tcol[i].fs[k]
						rhudDataTable[9].color.fe[k] = rhudSData.tcol[i].fe[k]
					end
				end
				rhud.fillarc(0, 100, 9)
			end
		else
			rhud.fillarc(0, 100, 9)
			rhud.arctext[9]:SetText("")
		end
		rhud.hptext[2]:SetText(tostring(unitID.health))
		rhud.hptext[2]:SetFontColor(0, 1, 0)
		rhud.rstext[2]:SetText("")
		if unitID.health and unitID.healthMax then
			rhud.fillarc(unitID.health, unitID.healthMax, 8)
			rhud.arctext[unitID.hindex]:SetText(string.format("%s", (math.ceil(unitID.health/unitID.healthMax * 100))))
		end
		if unitID.mana then	rhud.rstext[2]:SetText(tostring(unitID.mana)) rhud.rstext[2]:SetFontColor(0, .5, 1)	rhud.fillarc(unitID.mana, unitID.manaMax, 9) rhud.arctext[unitID.rindex]:SetText(string.format("%s", (math.ceil(unitID.mana/unitID.manaMax * 100)))) end
		if unitID.energy then rhud.rstext[2]:SetText(tostring(unitID.energy)) rhud.rstext[2]:SetFontColor(1, 0, 1) rhud.fillarc(unitID.energy, unitID.energyMax, 9) rhud.arctext[unitID.rindex]:SetText(string.format("%s", (math.ceil(unitID.energy/unitID.energyMax * 100)))) end
		if unitID.power then rhud.rstext[2]:SetText(tostring(unitID.power))	rhud.rstext[2]:SetFontColor(1, 1, 0) rhud.fillarc(unitID.power, 100, 9) rhud.arctext[unitID.rindex]:SetText(string.format("%s", (math.ceil(unitID.power)))) end
		
		if unitID.pvp == true and rhudIconsDB[17].showicon == true then rhud.targetpvpicon:SetVisible(true) else rhud.targetpvpicon:SetVisible(false) end
		if unitID.mark and rhudIconsDB[18].showicon == true then
			rhud.targetmarkicon:SetTexture("Rift", rhud.RaidMarkerImages[unitID.mark])
			rhud.targetmarkicon:SetVisible(true)
		else
			rhud.targetmarkicon:SetVisible(false)
		end
		if unitID.name ~= nil and unitID.level ~= nil then
			if unitID.relation == "hostile" then rcolor = {1, 0, 0, 1} end
			if unitID.relation == "friendly" then rcolor = {0, 1, 0, 1} end
			if unitID.relation == nil then rcolor = {1, 1, 0, 1} end
			if unitID.calling and unitID.player then
				for i = 1, 4 do
					if unitID.calling == rhud.Calling[i] then
						rcolor = rhud.CallingColors[i]
					end
				end
			end
			name = unitID.level .. "  " .. unitID.name
			local trunc = math.floor(rhud.OptionsUIElements[12]:GetWidth() / (rhud.targetnametext:GetFontSize()/2))
			if string.len(name) > (trunc - 2) and string.len(name) ~= trunc then name = string.sub(name, 1, trunc)..".." end		
			rhud.targetnametext:SetText(name)
			rhud.targetnametext:SetFontColor(rcolor[1], rcolor[2], rcolor[3], 1)
		else
			rhud.targetnametext:SetText("")
		end
		rhud.OptionsUIElementsIcons[8]:SetTexture("RiftHud", "Textures/blank.png") 
		if unitID.calling and unitID.player then
			callingname = string.gsub(unitID.calling, "^%l", string.upper)
			rhud.targetclasstext:SetText(callingname)
		else
			callingname = ""
			if rhudIconsDB[8].showicon == true then rhud.OptionsUIElementsIcons[8]:SetVisible(true) end
			if unitID.tier == nil then callingname = "" rhud.OptionsUIElementsIcons[8]:SetTexture("RiftHud", "Textures/blank.png") end
			if unitID.tier == "group" then callingname = "Elite" rhud.OptionsUIElementsIcons[8]:SetTexture("RiftHud", "Textures/tier_elite.png") end
			if unitID.tier == "raid" then callingname = "Raid Elite" rhud.OptionsUIElementsIcons[8]:SetTexture("RiftHud", "Textures/tier_raid.png") end
			if unitID.guaranteedLoot then callingname = "Rare" rhud.OptionsUIElementsIcons[8]:SetTexture("RiftHud", "Textures/tier_rare.png") end
			if unitID.level == "??" then callingname = "Boss" rhud.OptionsUIElementsIcons[8]:SetTexture("RiftHud", "Textures/tier_boss.png") end
			rhud.targetclasstext:SetText(callingname)
		end
		rhud.targetBuffs = {}
		buffs = Inspect.Buff.List(unitID.id)
		rhud.BuffsAdded(hEvent, unitID.id, buffs)
		rhud.CastbarUpdated = false
	else
		rhud.unitBuffsID.target = nil
		rhud.unitDB["player.target"] = nil
		if rhudSData.isincombat == false then rhud.Window:SetAlpha(rhudSData.aoc) rhud.targetnameback:SetVisible(false) rhud.targettnameback:SetVisible(false) end
		if rhudSData.misc[5] == false and rhudSData.isincombat == false then rhud.arc[8]:SetVisible(rhudSData.misc[5]) rhud.arc[9]:SetVisible(rhudSData.misc[5]) end
		rhud.fillarc(0, 100, 8)
		rhud.fillarc(0, 100, 9)
		rhud.fillarc(0, 100, 12)
		rhud.arctext[8]:SetText("")
		rhud.arctext[9]:SetText("")
		rhud.targetnametext:SetText("")
		rhud.targetclasstext:SetText("")
		rhud.targettargettext:SetText("")
		rhud.targetmarkicon:SetVisible(false)
		rhud.OptionsUIElementsIcons[8]:SetTexture("RiftHud", "Textures/blank.png")
		rhud.CastbarUpdated = false
		rhud.targetpvpicon:SetVisible(false)
		rhud.arc[12]:SetVisible(false)
		rhud.arctext[12]:SetText("")
		rhud.hptext[2]:SetText("")
		rhud.rstext[2]:SetText("")
		for a = 1, rhud.tbuffrowmax do
			rhud.bufftext[a]:SetText("")
			rhud.buffimg[a]:SetVisible(false)
		end
		rhud.targetBuffs = {}
		return
	end
end
function rhud.PlayerFocusChange(hEvent,focusID)
	if rhudDataTable[6].enabled == false and rhudDataTable[7].enabled == false then return end
	if focusID then
		rhud.unitDB["focus"] = {unit = "focus", index = 4, hindex = 6, rindex = 7}
		rhud.BuildTable("focus")
		local unitID = rhud.unitDB["focus"]
		if unitID.calling then
			for i = 1, 4 do
				if unitID.calling == rhud.Calling[i] then
					for k = 1, 4 do
						rhudDataTable[7].color.fs[k] = rhudSData.fcol[i].fs[k]
						rhudDataTable[7].color.fe[k] = rhudSData.fcol[i].fe[k]
					end
				end
			end
		else
			rhud.fillarc(0, 100, 7)
			rhud.arctext[7]:SetText("")
		end
		if unitID.health and unitID.healthMax then
			rhud.fillarc(unitID.health, unitID.healthMax, 6)
			rhud.arctext[unitID.hindex]:SetText(string.format("%s", (math.ceil(unitID.health/unitID.healthMax * 100))))
		end
		if unitID.mana then	rhud.rstext[2]:SetText(tostring(unitID.mana)) rhud.rstext[2]:SetFontColor(0, .5, 1)	rhud.fillarc(unitID.mana, unitID.manaMax, 7) rhud.arctext[unitID.rindex]:SetText(string.format("%s", (math.ceil(unitID.mana/unitID.manaMax * 100)))) end
		if unitID.energy then rhud.rstext[2]:SetText(tostring(unitID.energy)) rhud.rstext[2]:SetFontColor(1, 0, 1) rhud.fillarc(unitID.energy, unitID.energyMax, 7) rhud.arctext[unitID.rindex]:SetText(string.format("%s", (math.ceil(unitID.energy/unitID.energyMax * 100)))) end
		if unitID.power then rhud.rstext[2]:SetText(tostring(unitID.power))	rhud.rstext[2]:SetFontColor(1, 1, 0) rhud.fillarc(unitID.power, 100, 7) rhud.arctext[unitID.rindex]:SetText(string.format("%s", (math.ceil(unitID.power)))) end
		if rhudDataTable[6].enabled == true then rhud.arc[6]:SetVisible(true) end
		if rhudDataTable[7].enabled == true then rhud.arc[7]:SetVisible(true) end
	else
		rhud.unitDB["focus"] = nil
		rhud.arc[6]:SetVisible(false)
		rhud.arc[7]:SetVisible(false)
	end
end

function rhud.PlayerPetChange(hEvent,petID)
	if rhudDataTable[5].enabled == false then return end
	if petID then
		rhud.unitDB["player.pet"] = {unit = "player.pet", index = 3, hindex = 5, rindex = 0}
		rhud.BuildTable("player.pet")
		rhud.arc[5]:SetVisible(true)
		local unitID = rhud.unitDB["player.pet"]
		rhud.unitBuffsID.pet = unitID.id
		if unitID.health and unitID.healthMax then
			rhud.arctext[5]:SetText(string.format("%s", (math.ceil(unitID.health/unitID.healthMax * 100)))) 
			rhud.fillarc(unitID.health, unitID.healthMax, 5)
		end
	else
		rhud.unitDB["player.pet"] = nil
		rhud.unitBuffsID.pet = ""
		rhud.arc[5]:SetVisible(false)
	end
end
function rhud.TargetTargetChange(hEvent,ttargetID)
	if rhudDataTable[10].enabled == false then return end
	if ttargetID then
		rhud.unitDB["player.target.target"] = {unit = "player.target.target", index = 5, hindex = 10, rindex = 0}
		rhud.BuildTable("player.target.target")
		local unitID = rhud.unitDB["player.target.target"]
		if unitID.availability then
			name = unitID.name
			local trunc = math.floor(rhud.OptionsUIElements[13]:GetWidth() / (rhud.targettargettext:GetFontSize()/2))
			if string.len(name) > (trunc - 2) and string.len(name) ~= trunc then name = string.sub(name, 1, trunc)..".." end		
			rhud.targettargettext:SetText(name)
		end
		rhud.arc[10]:SetVisible(true)
		if rhudSData.isincombat == false and rhudSData.misc[4] == true then rhud.targettnameback:SetVisible(true) end
		if unitID.health and unitID.healthMax then
			rhud.fillarc(unitID.health, unitID.healthMax, 10)
			rhud.arctext[unitID.hindex]:SetText(string.format("%s", (math.ceil(unitID.health/unitID.healthMax * 100))))
		end
	else
		rhud.unitDB["player.target.target"] = nil
		if rhudSData.isincombat == false then rhud.targettnameback:SetVisible(false) end
		rhud.arc[10]:SetVisible(false)
		rhud.targettargettext:SetText("")
	end
end
