local addon, rhud = ...

function rhud.createWindow()
	rhud.WindowDrag:SetTexture("Rift", "button_advUI_(over).png.dds")
	rhud.WindowDrag:SetWidth(100)
	rhud.WindowDrag:SetHeight(100)
	rhud.WindowDrag:SetPoint("TOPLEFT", rhud.Context, "TOPLEFT", rhudSData.locmainx, rhudSData.locmainy)
	rhud.WindowDrag:SetVisible(false)
	rhud.Window:SetPoint("CENTER", rhud.WindowDrag, "CENTER")
	rhud.Window:SetAlpha(rhudSData.aoc)
	for i = 1, 12 do
		if rhudDataTable[i].x < 0 then tx = -1 * rhudSData.gap end
		if rhudDataTable[i].x > 0 then tx = rhudSData.gap end
		if rhudDataTable[i].x == 0 then tx = 0 end
		rhud.arcback[i]:SetPoint("CENTER", rhud.Window, "CENTER", rhudDataTable[i].x + tx, rhudDataTable[i].y)
		rhud.arcback[i]:SetWidth(rhudSData.size[rhudSData.skinval][rhudDataTable[i].scaledim].w * rhudDataTable[i].scale.w / 100)
		rhud.arcback[i]:SetHeight(rhudSData.size[rhudSData.skinval][rhudDataTable[i].scaledim].h * rhudDataTable[i].scale.h / 100)
		rhud.arcback[i]:SetVisible(false)
		rhud.arcbackTT[i]:InjectEvents(rhud.arcback[i], function ()
			local arcTT = "Center X: " .. rhudDataTable[i].x .. "\nCenter Y: " .. rhudDataTable[i].y
			return arcTT	end)

		rhud.arc[i]:SetPoint("TOPLEFT", rhud.arcback[i], "TOPLEFT")
		rhud.arc[i]:SetPoint("BOTTOMRIGHT", rhud.arcback[i], "BOTTOMRIGHT")
		rhud.arc[i]:SetShape(rhud.path[rhudDataTable[i].pos], rhud.fill[i], rhud.stroke)
		rhud.arc[i]:SetVisible(rhudDataTable[i].enabled)

		rhud.arctextback[i]:SetPoint("CENTER", rhud.arc[i], "CENTER", rhudDataTable[i].tx, rhudDataTable[i].ty)
		rhud.arctextback[i]:SetWidth(rhudDataTable[i].tw)
		rhud.arctextback[i]:SetHeight(rhudDataTable[i].th)
		rhud.arctextback[i]:SetVisible(false)
		rhud.arctextbackTT[i]:InjectEvents(rhud.arctextback[i], function ()
			local arctextTT = "Center X: " .. rhudDataTable[i].tx .. "\nCenter Y: " .. rhudDataTable[i].ty
			return arctextTT	end)
		rhud.arctext[i]:SetPoint("TOPCENTER", rhud.arctextback[i], "TOPCENTER")
		rhud.arctext[i]:SetPoint("BOTTOM", rhud.arctextback[i], "BOTTOM")
		rhud.arctext[i]:SetFontSize(rhudDataTable[i].font)
		rhud.arctext[i]:SetFontColor(rhudDataTable[i].fontc[1], rhudDataTable[i].fontc[2], rhudDataTable[i].fontc[3], 1)
		rhud.arctext[i]:SetText("")
		rhud.arctext[i]:SetEffectGlow(rhud.glowTable)
		rhud.arctext[i]:SetVisible(rhudDataTable[i].showicon == true)
	end
	for i = 1, 19 do
		rhud.OptionsUIElements[i]:SetPoint("CENTER", rhud.Window, "CENTER", rhudIconsDB[i].x, rhudIconsDB[i].y)
		rhud.OptionsUIElements[i]:SetWidth(rhudIconsDB[i].width)
		rhud.OptionsUIElements[i]:SetHeight(rhudIconsDB[i].height)
		rhud.OptionsUIElements[i]:SetLayer(rhudIconsDB[i].layer)
		rhud.OptionsUIElements[i]:SetSecureMode(rhudIconsDB[i].secure)
		rhud.OptionsUIElementsTT[i]:InjectEvents(rhud.OptionsUIElements[i], function ()
			local elementTT = "Center X: " .. rhudIconsDB[i].x .. "\nCenter Y: " .. rhudIconsDB[i].y
			return elementTT	end)
		rhud.OptionsUIElements[i]:SetVisible(false)
	end
	for i = 1, 8 do
		rhud.OptionsUIElementsIcons[i]:SetTexture(rhud.OptionsUIElementsIconsTable[i].addon, rhud.OptionsUIElementsIconsTable[i].texture)
		rhud.OptionsUIElementsIcons[i]:SetPoint("TOPLEFT", rhud.OptionsUIElements[i], "TOPLEFT")
		rhud.OptionsUIElementsIcons[i]:SetPoint("BOTTOMRIGHT", rhud.OptionsUIElements[i], "BOTTOMRIGHT")
		rhud.OptionsUIElementsIcons[i]:SetLayer(rhud.OptionsUIElementsIconsTable[i].layer)
		rhud.OptionsUIElementsIcons[i]:SetSecureMode(rhud.OptionsUIElementsIconsTable[i].secure)
		rhud.OptionsUIElementsIcons[i]:SetVisible(rhudIconsDB[i].showicon)
	end
	
	for i = 1, 4 do
		rhud.OptionsUIElementsText[i]:SetPoint("CENTER", rhud.OptionsUIElements[i], "CENTER")
		rhud.OptionsUIElementsText[i]:SetLayer(rhud.OptionsUIElementsTextTable[i].layer)
		rhud.OptionsUIElementsText[i]:SetFontSize(rhudIconsDB[i].font)
		rhud.OptionsUIElementsText[i]:SetEffectGlow(rhud.glowTable)
		rhud.OptionsUIElementsText[i]:SetSecureMode(rhud.OptionsUIElementsTextTable[i].secure)
		rhud.OptionsUIElementsText[i]:SetVisible(rhudIconsDB[i].showicon)
		end
		rhud.OptionsUIElementsText[5]:SetPoint("CENTER", rhud.OptionsUIElements[14], "CENTER")
		rhud.OptionsUIElementsText[5]:SetFontSize(rhudIconsDB[14].font)
		rhud.OptionsUIElementsText[5]:SetFontColor(0, .35, 1, 1)
		rhud.OptionsUIElementsText[5]:SetEffectGlow(rhud.glowTable)

	rhud.OptionsUIElementsIcons[7]:SetVisible(false)
	if rhudDataTable[10].showicon == false then rhud.arcback[10]:SetVisible(false) end
	rhud.buffimg[1]:SetPoint("TOPLEFT", rhud.OptionsUIElements[16], "TOPLEFT", 0, 0) 
	rhud.buffimg[1]:SetTexture(rhud.addonId, "Textures/blank.png")
	rhud.buffimg[1]:SetHeight(32)
	rhud.buffimg[1]:SetWidth(32)
	rhud.buffimg[1]:SetLayer(2)
	rhud.buffimg[1]:SetVisible(false)
	rhud.buffimg[1]:SetMouseMasking("limited")
	rhud.buffimg[1]:EventAttach(Event.UI.Input.Mouse.Cursor.In, function()	rhud.TooltipShow(1, 1) end, "ShowTooltip" )
	rhud.buffimg[1]:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function() rhud.TooltipHide(1, 1) end, "ShowTooltip" )
	rhud.bufftext[1]:SetPoint("CENTER", rhud.buffimg[1], "CENTER") 
	rhud.bufftext[1]:SetFontSize(14)
	rhud.bufftext[1]:SetLayer(3)
	rhud.bufftext[1]:SetEffectGlow(rhud.glowTable)
	rhud.bufftext[1]:SetText("")
	rhud.pbuffimg[1]:SetPoint("TOPRIGHT", rhud.OptionsUIElements[15], "TOPRIGHT", 0, 0) 
	rhud.pbuffimg[1]:SetTexture(rhud.addonId, "Textures/blank.png")
	rhud.pbuffimg[1]:SetHeight(32)
	rhud.pbuffimg[1]:SetWidth(32)
	rhud.pbuffimg[1]:SetLayer(2)
	rhud.pbuffimg[1]:SetVisible(false)
	rhud.pbuffimg[1]:SetBackgroundColor(.60, 1, 1, .2)
	rhud.pbuffimg[1]:SetMouseMasking("limited")
	rhud.pbufftext[1]:SetPoint("CENTER", rhud.pbuffimg[1], "CENTER") 
	rhud.pbufftext[1]:SetFontSize(14)
	rhud.pbufftext[1]:SetLayer(3)
	rhud.pbufftext[1]:SetEffectGlow(rhud.glowTable)
	rhud.pbufftext[1]:SetText("")
	rhud.pbuffimg[1]:EventAttach(Event.UI.Input.Mouse.Cursor.In, function()	rhud.TooltipShow(2, 1) end, "ShowTooltip" )
	rhud.pbuffimg[1]:EventAttach(Event.UI.Input.Mouse.Cursor.Out, function() rhud.TooltipHide(2, 1) end, "ShowTooltip" )
	rhud.combomask:SetPoint("TOPLEFT", rhud.OptionsUIElements[9], "TOPLEFT")
	rhud.combomask:SetPoint("BOTTOM", rhud.OptionsUIElements[9], "BOTTOM")
	rhud.combomask:SetWidth(0)
	rhud.combomask:SetVisible(rhudIconsDB[9].showicon)
	rhud.combo:SetTexture(rhud.addonId, "Textures/blank.png")
	rhud.combo:SetPoint("TOPLEFT", rhud.OptionsUIElements[9], "TOPLEFT")
	rhud.combo:SetPoint("BOTTOMRIGHT", rhud.OptionsUIElements[9], "BOTTOMRIGHT")
	rhud.combo:SetVisible(rhudIconsDB[9].showicon)

	rhud.hptext[1]:SetPoint("TOPCENTER", rhud.OptionsUIElements[10], "TOPCENTER")	
	rhud.hptext[1]:SetFontSize(rhudIconsDB[10].font)	
	rhud.hptext[1]:SetEffectGlow(rhud.glowTable)	
	rhud.hptext[1]:SetVisible(rhudIconsDB[10].showicon)
	rhud.hptext[1]:SetLayer(5)	
	rhud.hptext[1]:SetText("")	

	rhud.rstext[1]:SetPoint("BOTTOMCENTER", rhud.OptionsUIElements[10], "BOTTOMCENTER")	
	rhud.rstext[1]:SetFontSize(rhudIconsDB[10].font)	
	rhud.rstext[1]:SetEffectGlow(rhud.glowTable)	
	rhud.rstext[1]:SetVisible(rhudIconsDB[10].showicon)	
	rhud.rstext[1]:SetLayer(5)	
	rhud.rstext[1]:SetText("")	

	rhud.hptext[2]:SetPoint("TOPCENTER", rhud.OptionsUIElements[11], "TOPCENTER")	
	rhud.hptext[2]:SetFontSize(rhudIconsDB[11].font)	
	rhud.hptext[2]:SetEffectGlow(rhud.glowTable)	
	rhud.hptext[2]:SetVisible(rhudIconsDB[11].showicon)	
	rhud.hptext[2]:SetLayer(5)	
	rhud.hptext[2]:SetText("")	

	rhud.rstext[2]:SetPoint("BOTTOMCENTER", rhud.OptionsUIElements[11], "BOTTOMCENTER")	
	rhud.rstext[2]:SetFontSize(rhudIconsDB[11].font)	
	rhud.rstext[2]:SetEffectGlow(rhud.glowTable)	
	rhud.rstext[2]:SetVisible(rhudIconsDB[11].showicon)	
	rhud.rstext[2]:SetLayer(5)	
	rhud.rstext[2]:SetText("")	

	
	rhud.targetnameback:SetPoint("TOPLEFT", rhud.OptionsUIElements[12], "TOPLEFT")
	rhud.targetnameback:SetPoint("BOTTOMRIGHT", rhud.OptionsUIElements[12], "BOTTOMRIGHT")
	rhud.targetnameback:SetSecureMode("restricted")
	rhud.targetnameback:SetMouseMasking("limited")
	rhud.targetnametext:SetPoint("TOPCENTER", rhud.targetnameback, "TOPCENTER")
	rhud.targetnametext:SetLayer(3)
	rhud.targetnametext:SetFontSize(rhudIconsDB[12].font)
	rhud.targetnametext:SetEffectGlow(rhud.glowTable)
	rhud.targetnametext:SetVisible(rhudIconsDB[12].showicon)	
	rhud.targetnameback:SetVisible(false)

	rhud.targetclasstext:SetPoint("TOPCENTER", rhud.OptionsUIElements[19], "TOPCENTER")
	rhud.targetclasstext:SetLayer(3)
	rhud.targetclasstext:SetFontSize(rhudIconsDB[19].font)
	rhud.targetclasstext:SetEffectGlow(rhud.glowTable)
	rhud.targetclasstext:SetVisible(rhudIconsDB[19].showicon)	

	rhud.targettnameback:SetPoint("TOPLEFT", rhud.OptionsUIElements[13], "TOPLEFT")
	rhud.targettnameback:SetPoint("BOTTOMRIGHT", rhud.OptionsUIElements[13], "BOTTOMRIGHT")
	rhud.targettnameback:SetSecureMode("restricted")
	rhud.targettnameback:SetMouseMasking("limited")
	rhud.targettargettext:SetPoint("CENTER", rhud.targettnameback, "CENTER")
	rhud.targettargettext:SetLayer(3)
	rhud.targettargettext:SetFontSize(rhudIconsDB[13].font)
	rhud.targettargettext:SetFontColor(1, 0.5, 0, 1)
	rhud.targettargettext:SetEffectGlow(rhud.glowTable)
	rhud.targettargettext:SetText("")
	rhud.targettnameback:SetVisible(false)
	
	rhud.targetpvpicon:SetTexture(rhud.addonId, "Textures/pvp.png")
	rhud.targetpvpicon:SetPoint("TOPLEFT", rhud.OptionsUIElements[17], "TOPLEFT")
	rhud.targetpvpicon:SetPoint("BOTTOMRIGHT", rhud.OptionsUIElements[17], "BOTTOMRIGHT")
	rhud.targetpvpicon:SetVisible(false)

	rhud.targetmarkicon:SetPoint("TOPLEFT", rhud.OptionsUIElements[18], "TOPLEFT")
	rhud.targetmarkicon:SetPoint("BOTTOMRIGHT", rhud.OptionsUIElements[18], "BOTTOMRIGHT")
	rhud.targetmarkicon:SetVisible(false)


end
function rhud.createWindowEvents()
	function rhud.targetrclickmenu()
		if rhudSData.misc[3] == true then
			if (rhud.targetnameback:GetVisible() == true and string.len(rhud.targetnametext:GetText()) > 1) then Command.Unit.Menu("player.target") end
		end
	end
	rhud.targetnameback:EventAttach(Event.UI.Input.Mouse.Right.Click, rhud.targetrclickmenu, "RightClick")
	rhud.targettnameback:EventMacroSet(Event.UI.Input.Mouse.Left.Click, "target @player.target.target")
	rhud.OptionsUIElementsText[1]:EventAttach(Event.UI.Input.Mouse.Left.Click, function() rhud.toggleConfig() end, "LeftClick")
	rhud.OptionsUIElementsText[1]:EventAttach(Event.UI.Input.Mouse.Middle.Click, function()
		if rhudSData.isincombat == false then
			if rhudSData.islocked == true then
				rhudSData.islocked = false
				rhud.WindowDrag:SetVisible(true)
				rhud.dragframe(rhud.WindowDrag, rhud.windowmove, true)
			else
				rhudSData.islocked = true
				rhud.WindowDrag:SetVisible(false)
				rhud.dragframe(rhud.WindowDrag, nil, false)
			end
		end
	end, "LeftClick")
	rhud.OptionsUIElementsText[1]:EventAttach(Event.UI.Input.Mouse.Right.Click, function() Command.Unit.Menu("player") end, "RightClick")
	if rhudSData.misc[2] == true then
	rhud.WindowTooltip:InjectEvents(rhud.OptionsUIElementsText[1], function ()
		stattext = "Click to Open Options \n"
		stattext = stattext .. "Middle Click to Move \n"
		stattext = stattext .. rhud.PlayerStat[1] .. ":  " .. rhud.PlayerStat[2] .. " / " .. rhud.PlayerStat[3] .. "\n"
		stattext = stattext .. rhud.PlayerStat[4] .. ":  " .. rhud.PlayerStat[5] .. " / " .. rhud.PlayerStat[6] .. "\n"
		stattext = stattext .. rhud.PlayerStat[7] .. ":  " .. rhud.PlayerStat[8] .. " / " .. rhud.PlayerStat[9] .. "\n"
		return stattext
		end)
	end

	rhud.tooltipval = false
	function rhud.TooltipShow(frame, pos)
		if rhudSData.misc[2] ~= true then return end
		if frame == 1 then
			if rhud.targetBuffs[pos].bid ~= nil then
				rhud.tooltipval = pos
				Command.Tooltip(rhud.unitBuffsID.target, rhud.targetBuffs[pos].bid)
			end
		end
		if frame == 2 then
			if rhud.unitBuffs[pos].bid ~= nil then
				rhud.tooltipval = pos
				Command.Tooltip(rhud.unitBuffsID.player, rhud.unitBuffs[pos].bid)
			end
		end
	end
	function rhud.TooltipHide(frame, pos)
		if rhudSData.misc[2] ~= true then return end
		if rhud.tooltipval == pos then Command.Tooltip(nil) end
	end
end